/* solver.c */
/* Last Change: 2018/08/27 (Mon) 23:42:09. */

#define MAX_ATTEMPS 10000

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
/* #include<limits.h> */
/* #include<math.h> */
#include<time.h>

int board[8][72][72]={};
int avail[8][72][72]={}; //start=3,path=2,avail=1,nonavail=0,goal=-1
int connected[8*72*72/2+1]={}; //connected[0]=(number of connected lines)
int depth,height,width;
int goalx,goaly,goalz;
int lines;
int dx[6]={-1,0,0,1,0,0};
int dy[6]={0,-1,0,0,1,0};
int dz[6]={0,0,-1,0,0,1};
int history[8*72*72];
int searchorder[6]; //x+-,y+-,z+-
//z,y,x

void read(void){ //read problem
	int x,y,z,i;
	char c,str[8];
	scanf(" %s",str); //SIZE
	scanf(" %d",&width);
	if(width>72||width<=0)
		printf("Error: width\n");
	scanf(" %c",&c); //X
	scanf(" %d",&height);
	if(height>72||height<=0)
		printf("Error: height\n");
	scanf(" %c",&c); //X
	scanf(" %d",&depth);
	if(depth>8||depth<=0)
		printf("Error: depth\n");
	scanf(" %s",str); //LINE_NUM
	scanf(" %d",&lines);
	if(lines<=0)
		printf("Error: lines\n");
	for(i=1;i<=lines;i++){
		scanf(" %s",str); //LINE#X
		scanf(" %c",&c); //(
		scanf(" %d",&x);
		if(x>=72||x<0)
			printf("Error: x\n");
		scanf(" %c",&c); //,
		scanf(" %d",&y);
		if(y>=72||y<0)
			printf("Error: y\n");
		scanf(" %c",&c); //,
		scanf(" %d",&z);
		if(z>=72||z<0)
			printf("Error: z\n");
		scanf(" %c",&c); //)
		board[z-1][y][x]=-i;
		scanf("%c",&c); //)
		/* scanf(" %[ -]",&c); //space or - */
		scanf(" %c",&c); //(
		scanf(" %d",&x);
		if(x>=72||x<0)
			printf("Error: x\n");
		scanf(" %c",&c); //,
		scanf(" %d",&y);
		if(y>=72||y<0)
			printf("Error: y\n");
		scanf(" %c",&c); //,
		scanf(" %d",&z);
		if(z>=72||z<0)
			printf("Error: z\n");
		scanf(" %c",&c); //)
		board[z-1][y][x]=-i;
	}
	return;
}

int available(int z,int y, int x){ //return 1 when (nowx,nowy,nowz) can be connected to goal
	int i,j,t,src=0,contd,isbranch;
	int index=0;
	int nowx=x,nowy=y,nowz=z;
	/* for(i=0;i<6;i++) */
	/* printf("%d %d %d\n",dx[i],dy[i],dz[i]); */
	for(i=0;i<8*72*72;i++)
		history[i]=-1;
	index=0;
	while(1){
		/* printf("%d %d %d\n",nowx,nowy,nowz); */
		if(nowx<0||nowy<0||nowz<0||nowx>=width||nowy>=height||nowz>=depth){
			printf("error %d %d %d\n",nowx,nowy,nowz);
			/* printf("%d, %d\n",index,history[index]); */
			/* printf("%d %d %d\n",dx[history[index]],dy[history[index]],dz[history[index]]); */
			return 0;
		}
		if(avail[nowz][nowy][nowx]==-1){ //goal
			return 1;
		}
		isbranch=-1;
		if(nowx>0&&avail[nowz][nowy][nowx-1]>=2)
			isbranch++;
		if(nowy>0&&avail[nowz][nowy-1][nowx]>=2)
			isbranch++;
		if(nowz>0&&avail[nowz-1][nowy][nowx]>=2)
			isbranch++;
		if(nowx<width-1&&avail[nowz][nowy][nowx+1]>=2)
			isbranch++;
		if(nowy<height-1&&avail[nowz][nowy+1][nowx]>=2)
			isbranch++;
		if(nowz<depth-1&&avail[nowz+1][nowy][nowx]>=2)
			isbranch++;
		if(isbranch>0&&index){
			avail[nowz][nowy][nowx]=0;
			index--;
			if(nowx-dx[history[index]]<0||nowy-dy[history[index]]<0||nowz-dx[history[index]]<0||nowx-dz[history[index]]>=width||nowy-dy[history[index]]>=height||nowz-dz[history[index]]>=depth){
				index++;
				/* printf("something wrong\n"); */
			}else{
				nowx-=dx[history[index]];
				nowy-=dy[history[index]];
				nowz-=dz[history[index]];
				avail[nowz][nowy][nowx]=1;
				/* printf("%d %d %d -%d %d\n",nowx,nowy,nowz,history[index],index); */
				/* for(j=0;j<index;j++) */
				/* 	printf("%d ",history[j]); */
				/* printf("\n"); */
				/* return 0;//goback */
				continue;
			}
		}
		if(avail[nowz][nowy][nowx]==1)
			avail[nowz][nowy][nowx]=2;
		if(nowx>goalx){
			searchorder[src]=0;
			src++;
		}else
			searchorder[5+src]=0;
		if(nowy>goaly){
			searchorder[src]=1;
			src++;
		}else
			searchorder[4+src]=1;
		if(nowz>goalz){
			searchorder[src]=2;
			src++;
		}else
			searchorder[3+src]=2;
		if(nowx<goalx){
			searchorder[src]=3;
			src++;
		}else
			searchorder[2+src]=3;
		if(nowy<goaly){
			searchorder[src]=4;
			src++;
		}else
			searchorder[1+src]=4;
		if(nowz<goalz){
			searchorder[src]=5;
			src++;
		}else
			searchorder[src]=5;
		for(i=0;i<src;i++){
			j=rand()%(src);
			t=searchorder[i];
			searchorder[i]=searchorder[j];
			searchorder[j]=t;
		}
		for(i=src;i<6;i++){
			j=src+rand()%(6-src);
			t=searchorder[i];
			searchorder[i]=searchorder[j];
			searchorder[j]=t;
		}
		contd=1;
		for(i=0;i<6&&contd;i++){
			/* printf("%d\n",searchorder[i]); */
			if(nowx+dx[searchorder[i]]<0||nowy+dy[searchorder[i]]<0||nowz+dx[searchorder[i]]<0||nowx+dz[searchorder[i]]>=width||nowy+dy[searchorder[i]]>=height||nowz+dz[searchorder[i]]>=depth)
				continue;
			if(avail[nowz+dz[searchorder[i]]][nowy+dy[searchorder[i]]][nowx+dx[searchorder[i]]]==1){
				contd=0;
				nowx+=dx[searchorder[i]];
				nowy+=dy[searchorder[i]];
				nowz+=dz[searchorder[i]];
				/* printf("%d %d %d\n",dx[searchorder[i]],dy[searchorder[i]],dz[searchorder[i]]); */
				history[index]=searchorder[i];
				/* printf("%d %d %d +%d %d\n",nowx,nowy,nowz,searchorder[i],index+1); */
				/* for(j=0;j<index;j++) */
				/* 	printf("%d ",history[j]); */
				/* printf("\n"); */
				index++;
			}
		}
		if(avail[nowz][nowy][nowx]==3||index==0)
			return 0;
		if(contd&&index){
			avail[nowz][nowy][nowx]=0;
			index--;
			if(nowx-dx[history[index]]<0||nowy-dy[history[index]]<0||nowz-dx[history[index]]<0||nowx-dz[history[index]]>=width||nowy-dy[history[index]]>=height||nowz-dz[history[index]]>=depth){
				index++;
				/* printf("something wrong\n"); */
			}else{
				nowx-=dx[history[index]];
				nowy-=dy[history[index]];
				nowz-=dz[history[index]];
				avail[nowz][nowy][nowx]=1;
				/* printf("%d %d %d -%d %d\n",nowx,nowy,nowz,history[index],index); */
				/* for(j=0;j<index;j++) */
				/* 	printf("%d ",history[j]); */
				/* printf("\n"); */
				/* printf("%d %d %d\n",dx[history[index]],dy[history[index]],dz[history[index]]); */
				continue;
			}
		}
	}
	return 0;
}

int connectable(int linea,int lineb){ //return 1 if linea can be connected when lineb is deleted
	int startx=-1,starty=-1,startz=-1,notfound=1;
	int i,j,k;
	for(i=0;i<depth;i++)
		for(j=0;j<height;j++)
			for(k=0;k<width;k++)
				if(board[i][j][k]==linea*(-1)){
					if(notfound){ //start
						startz=i;
						starty=j;
						startx=k;
						avail[i][j][k]=3;
						notfound=0;
					}else{ //goal
						goalz=i;
						goaly=j;
						goalx=k;
						avail[i][j][k]=-1;
						notfound=2;
					}
				}else if(board[i][j][k]==0||board[i][j][k]==lineb||board[i][j][k]==linea){
					avail[i][j][k]=1;
				}else{
					avail[i][j][k]=0;
				}
	if(startx==-1||starty==-1||startz==-1||notfound!=2){
		printf("Error: Line %d\n",linea);
		return 0;
	}
	return available(startz,starty,startx);
}

void connect(int line){ //connect line
	int i,j,k;
	for(i=0;i<depth;i++)
		for(j=0;j<height;j++)
			for(k=0;k<width;k++)
				if(avail[i][j][k]==2){
					if(board[i][j][k]==0)
						board[i][j][k]=line;
					else
						printf("something wrong");
				}
	return;
}

void delete(int line){ //delete line
	int i,j,k;
	for(i=0;i<depth;i++)
		for(j=0;j<height;j++)
			for(k=0;k<width;k++)
				if(board[i][j][k]==line)
					board[i][j][k]=0;
	return;
}

int solve(void){ //return 1 when solved, 0 when cannot
	int i,linea,lineb[10000];
	for(i=0;i<MAX_ATTEMPS;i++){ //try to connect MAX_ATTEMPS times
		linea=rand()%lines+1;
		if(connected[linea])
			continue;
		if(connectable(linea,0)){ //if linea canbe conneced without deleting lines
			connect(linea);
			connected[linea]=1;
			connected[0]++;
			if(connected[0]==lines)
				return 1;
		}else{
			int j,t;
			for(i=0;i<lines;i++){
				lineb[i]=i+1;
			}
			for(i=0;i<lines;i++){ //shuffle
				j=rand()%(lines);
				t=lineb[i];
				lineb[i]=lineb[j];
				lineb[j]=t;
			}
			for(i=0;i<lines;i++){
				if(connectable(linea,lineb[i])){
					delete(lineb[i]);
					connect(linea);
					connected[linea]=1;
					connected[lineb[i]]=0;
					break;
				}
				if(j==MAX_ATTEMPS-1){
					return 0;
				}
			}
		}
	}
	return 0;
}

void write(void){
	int i,j,k;
	printf("SIZE %dX%dX%d\n",width,height,depth);
	for(k=0;k<depth;k++){
		printf("LAYER %d\n",k+1);
		for(j=0;j<height;j++){
			for(i=0;i<width-1;i++){
				if(board[k][j][i]<0)
					board[k][j][i]=-board[k][j][i];
				printf("%d, ",board[k][j][i]);
			}
			if(board[k][j][i]<0)
				board[k][j][i]=-board[k][j][i];
			printf("%d",board[k][j][i]);
			printf("\n");
		}
	}
	return;
}

int main(void){
	srand((unsigned)time(NULL));
	read();
	if(solve())
		write();
	else
		printf("Cannot solve!\n");
	return 0;
}
